import{S as kn,i as yn,s as wn,e as o,k as d,w as h,t as l,M as xn,c as r,d as t,m as f,a as i,x as c,h as n,b as u,G as a,g as p,y as m,q as _,o as g,B as b,v as jn}from"../../chunks/vendor-hf-doc-builder.js";import{D as qn,T as En}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";import{I as Ce}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as w}from"../../chunks/CodeBlock-hf-doc-builder.js";function Pn(Tt){let v,Q,$,q,I;return{c(){v=o("p"),Q=l("\u{1F4A1} Read "),$=o("a"),q=l("Prefix-Tuning: Optimizing Continuous Prompts for Generation"),I=l(" to learn more about prefix tuning."),this.h()},l(j){v=r(j,"P",{});var T=i(v);Q=n(T,"\u{1F4A1} Read "),$=r(T,"A",{href:!0,rel:!0});var H=i($);q=n(H,"Prefix-Tuning: Optimizing Continuous Prompts for Generation"),H.forEach(t),I=n(T," to learn more about prefix tuning."),T.forEach(t),this.h()},h(){u($,"href","https://arxiv.org/abs/2101.00190"),u($,"rel","nofollow")},m(j,T){p(j,v,T),a(v,Q),a(v,$),a($,q),a(v,I)},d(j){j&&t(v)}}}function Sn(Tt){let v,Q,$,q,I,j,T,H,Sa,zt,ae,At,z,Ta,We,za,Aa,et,La,Ma,Lt,B,Mt,E,Ca,se,tt,Da,Ia,at,Na,Fa,le,Oa,Ua,Ct,De,Ra,Dt,ne,It,N,X,st,oe,Ga,lt,Qa,Nt,A,Ha,nt,Ba,Xa,ot,Ka,Va,Ft,re,Ot,F,K,rt,ie,Ya,it,Za,Ut,L,Ja,pt,Wa,es,pe,ut,ts,as,Rt,k,ss,ue,ls,ns,de,os,rs,dt,is,ps,ft,us,ds,fe,fs,hs,Gt,he,Qt,O,V,ht,ce,cs,ct,ms,Ht,M,_s,mt,gs,bs,_t,vs,$s,Bt,me,Xt,C,ks,_e,ys,ws,gt,xs,js,Kt,ge,Vt,x,qs,be,bt,Es,Ps,vt,Ss,Ts,$t,zs,As,kt,Ls,Ms,Yt,ve,Zt,U,Y,yt,$e,Cs,wt,Ds,Jt,y,Is,Ie,Ns,Fs,xt,Os,Us,ke,Rs,Gs,Ne,Qs,Hs,Fe,Bs,Xs,Wt,ye,ea,Oe,Ks,ta,we,aa,Ue,Vs,sa,xe,la,Re,Ys,na,je,oa,Ge,Zs,ra,R,Z,jt,qe,Js,qt,Ws,ia,Qe,el,pa,Ee,ua,J,tl,Pe,al,sl,da,Se,fa,He,ll,ha,G,W,Et,Te,nl,Pt,ol,ca,Be,rl,ma,ze,_a,Xe,il,ga,Ae,ba,ee,pl,St,ul,dl,va,Le,$a;return j=new Ce({}),ae=new qn({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/seq2seq-prefix-tuning.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/pytorch/seq2seq-prefix-tuning.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/tensorflow/seq2seq-prefix-tuning.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/seq2seq-prefix-tuning.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/pytorch/seq2seq-prefix-tuning.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/tensorflow/seq2seq-prefix-tuning.ipynb"}]}}),B=new En({props:{$$slots:{default:[Pn]},$$scope:{ctx:Tt}}}),ne=new w({props:{code:"!pip install -q peft transformers datasets",highlighted:"!pip install -q peft transformers datasets"}}),oe=new Ce({}),re=new w({props:{code:`from transformers import AutoTokenizer, AutoModelForSeq2SeqLM, default_data_collator, get_linear_schedule_with_warmup
from peft import get_peft_config, get_peft_model, get_peft_model_state_dict, PrefixTuningConfig, TaskType
from datasets import load_dataset
from torch.utils.data import DataLoader
from tqdm import tqdm
import os

os.environ["TOKENIZERS_PARALLELISM"] = "false"
os.environ["CUDA_VISIBLE_DEVICES"] = "3"

device = "cuda"
model_name_or_path = "t5-large"
tokenizer_name_or_path = "t5-large"

text_column = "sentence"
label_column = "text_label"
max_length = 128
lr = 1e-2
num_epochs = 5
batch_size = 8`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoModelForSeq2SeqLM, default_data_collator, get_linear_schedule_with_warmup
<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> get_peft_config, get_peft_model, get_peft_model_state_dict, PrefixTuningConfig, TaskType
<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">from</span> torch.utils.data <span class="hljs-keyword">import</span> DataLoader
<span class="hljs-keyword">from</span> tqdm <span class="hljs-keyword">import</span> tqdm
<span class="hljs-keyword">import</span> os

os.environ[<span class="hljs-string">&quot;TOKENIZERS_PARALLELISM&quot;</span>] = <span class="hljs-string">&quot;false&quot;</span>
os.environ[<span class="hljs-string">&quot;CUDA_VISIBLE_DEVICES&quot;</span>] = <span class="hljs-string">&quot;3&quot;</span>

device = <span class="hljs-string">&quot;cuda&quot;</span>
model_name_or_path = <span class="hljs-string">&quot;t5-large&quot;</span>
tokenizer_name_or_path = <span class="hljs-string">&quot;t5-large&quot;</span>

text_column = <span class="hljs-string">&quot;sentence&quot;</span>
label_column = <span class="hljs-string">&quot;text_label&quot;</span>
max_length = <span class="hljs-number">128</span>
lr = <span class="hljs-number">1e-2</span>
num_epochs = <span class="hljs-number">5</span>
batch_size = <span class="hljs-number">8</span>`}}),ie=new Ce({}),he=new w({props:{code:`from datasets import load_dataset

dataset = load_dataset("financial_phrasebank", "sentences_allagree")
dataset = dataset["train"].train_test_split(test_size=0.1)
dataset["validation"] = dataset["test"]
del dataset["test"]

classes = dataset["train"].features["label"].names
dataset = dataset.map(
    lambda x: {"text_label": [classes[label] for label in x["label"]]},
    batched=True,
    num_proc=1,
)

dataset["train"][0]
{"sentence": "Profit before taxes was EUR 4.0 mn , down from EUR 4.9 mn .", "label": 0, "text_label": "negative"}`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

dataset = load_dataset(<span class="hljs-string">&quot;financial_phrasebank&quot;</span>, <span class="hljs-string">&quot;sentences_allagree&quot;</span>)
dataset = dataset[<span class="hljs-string">&quot;train&quot;</span>].train_test_split(test_size=<span class="hljs-number">0.1</span>)
dataset[<span class="hljs-string">&quot;validation&quot;</span>] = dataset[<span class="hljs-string">&quot;test&quot;</span>]
<span class="hljs-keyword">del</span> dataset[<span class="hljs-string">&quot;test&quot;</span>]

classes = dataset[<span class="hljs-string">&quot;train&quot;</span>].features[<span class="hljs-string">&quot;label&quot;</span>].names
dataset = dataset.<span class="hljs-built_in">map</span>(
    <span class="hljs-keyword">lambda</span> x: {<span class="hljs-string">&quot;text_label&quot;</span>: [classes[label] <span class="hljs-keyword">for</span> label <span class="hljs-keyword">in</span> x[<span class="hljs-string">&quot;label&quot;</span>]]},
    batched=<span class="hljs-literal">True</span>,
    num_proc=<span class="hljs-number">1</span>,
)

dataset[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&quot;sentence&quot;</span>: <span class="hljs-string">&quot;Profit before taxes was EUR 4.0 mn , down from EUR 4.9 mn .&quot;</span>, <span class="hljs-string">&quot;label&quot;</span>: <span class="hljs-number">0</span>, <span class="hljs-string">&quot;text_label&quot;</span>: <span class="hljs-string">&quot;negative&quot;</span>}`}}),ce=new Ce({}),me=new w({props:{code:`tokenizer = AutoTokenizer.from_pretrained(model_name_or_path)


def preprocess_function(examples):
    inputs = examples[text_column]
    targets = examples[label_column]
    model_inputs = tokenizer(inputs, max_length=max_length, padding="max_length", truncation=True, return_tensors="pt")
    labels = tokenizer(targets, max_length=2, padding="max_length", truncation=True, return_tensors="pt")
    labels = labels["input_ids"]
    labels[labels == tokenizer.pad_token_id] = -100
    model_inputs["labels"] = labels
    return model_inputs`,highlighted:`tokenizer = AutoTokenizer.from_pretrained(model_name_or_path)


<span class="hljs-keyword">def</span> <span class="hljs-title function_">preprocess_function</span>(<span class="hljs-params">examples</span>):
    inputs = examples[text_column]
    targets = examples[label_column]
    model_inputs = tokenizer(inputs, max_length=max_length, padding=<span class="hljs-string">&quot;max_length&quot;</span>, truncation=<span class="hljs-literal">True</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
    labels = tokenizer(targets, max_length=<span class="hljs-number">2</span>, padding=<span class="hljs-string">&quot;max_length&quot;</span>, truncation=<span class="hljs-literal">True</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
    labels = labels[<span class="hljs-string">&quot;input_ids&quot;</span>]
    labels[labels == tokenizer.pad_token_id] = -<span class="hljs-number">100</span>
    model_inputs[<span class="hljs-string">&quot;labels&quot;</span>] = labels
    <span class="hljs-keyword">return</span> model_inputs`}}),ge=new w({props:{code:`processed_datasets = dataset.map(
    preprocess_function,
    batched=True,
    num_proc=1,
    remove_columns=dataset["train"].column_names,
    load_from_cache_file=False,
    desc="Running tokenizer on dataset",
)`,highlighted:`processed_datasets = dataset.<span class="hljs-built_in">map</span>(
    preprocess_function,
    batched=<span class="hljs-literal">True</span>,
    num_proc=<span class="hljs-number">1</span>,
    remove_columns=dataset[<span class="hljs-string">&quot;train&quot;</span>].column_names,
    load_from_cache_file=<span class="hljs-literal">False</span>,
    desc=<span class="hljs-string">&quot;Running tokenizer on dataset&quot;</span>,
)`}}),ve=new w({props:{code:`train_dataset = processed_datasets["train"]
eval_dataset = processed_datasets["validation"]

train_dataloader = DataLoader(
    train_dataset, shuffle=True, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=True
)
eval_dataloader = DataLoader(eval_dataset, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=True)`,highlighted:`train_dataset = processed_datasets[<span class="hljs-string">&quot;train&quot;</span>]
eval_dataset = processed_datasets[<span class="hljs-string">&quot;validation&quot;</span>]

train_dataloader = DataLoader(
    train_dataset, shuffle=<span class="hljs-literal">True</span>, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=<span class="hljs-literal">True</span>
)
eval_dataloader = DataLoader(eval_dataset, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=<span class="hljs-literal">True</span>)`}}),$e=new Ce({}),ye=new w({props:{code:`peft_config = PrefixTuningConfig(task_type=TaskType.SEQ_2_SEQ_LM, inference_mode=False, num_virtual_tokens=20)

model = AutoModelForSeq2SeqLM.from_pretrained(model_name_or_path)
model = get_peft_model(model, peft_config)
model.print_trainable_parameters()
"trainable params: 983040 || all params: 738651136 || trainable%: 0.13308583065659835"`,highlighted:`peft_config = PrefixTuningConfig(task_type=TaskType.SEQ_2_SEQ_LM, inference_mode=<span class="hljs-literal">False</span>, num_virtual_tokens=<span class="hljs-number">20</span>)

model = AutoModelForSeq2SeqLM.from_pretrained(model_name_or_path)
model = get_peft_model(model, peft_config)
model.print_trainable_parameters()
<span class="hljs-string">&quot;trainable params: 983040 || all params: 738651136 || trainable%: 0.13308583065659835&quot;</span>`}}),we=new w({props:{code:`optimizer = torch.optim.AdamW(model.parameters(), lr=lr)
lr_scheduler = get_linear_schedule_with_warmup(
    optimizer=optimizer,
    num_warmup_steps=0,
    num_training_steps=(len(train_dataloader) * num_epochs),
)`,highlighted:`optimizer = torch.optim.AdamW(model.parameters(), lr=lr)
lr_scheduler = get_linear_schedule_with_warmup(
    optimizer=optimizer,
    num_warmup_steps=<span class="hljs-number">0</span>,
    num_training_steps=(<span class="hljs-built_in">len</span>(train_dataloader) * num_epochs),
)`}}),xe=new w({props:{code:`model = model.to(device)

for epoch in range(num_epochs):
    model.train()
    total_loss = 0
    for step, batch in enumerate(tqdm(train_dataloader)):
        batch = {k: v.to(device) for k, v in batch.items()}
        outputs = model(**batch)
        loss = outputs.loss
        total_loss += loss.detach().float()
        loss.backward()
        optimizer.step()
        lr_scheduler.step()
        optimizer.zero_grad()

    model.eval()
    eval_loss = 0
    eval_preds = []
    for step, batch in enumerate(tqdm(eval_dataloader)):
        batch = {k: v.to(device) for k, v in batch.items()}
        with torch.no_grad():
            outputs = model(**batch)
        loss = outputs.loss
        eval_loss += loss.detach().float()
        eval_preds.extend(
            tokenizer.batch_decode(torch.argmax(outputs.logits, -1).detach().cpu().numpy(), skip_special_tokens=True)
        )

    eval_epoch_loss = eval_loss / len(eval_dataloader)
    eval_ppl = torch.exp(eval_epoch_loss)
    train_epoch_loss = total_loss / len(train_dataloader)
    train_ppl = torch.exp(train_epoch_loss)
    print(f"{epoch=}: {train_ppl=} {train_epoch_loss=} {eval_ppl=} {eval_epoch_loss=}")`,highlighted:`model = model.to(device)

<span class="hljs-keyword">for</span> epoch <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(num_epochs):
    model.train()
    total_loss = <span class="hljs-number">0</span>
    <span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(tqdm(train_dataloader)):
        batch = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> batch.items()}
        outputs = model(**batch)
        loss = outputs.loss
        total_loss += loss.detach().<span class="hljs-built_in">float</span>()
        loss.backward()
        optimizer.step()
        lr_scheduler.step()
        optimizer.zero_grad()

    model.<span class="hljs-built_in">eval</span>()
    eval_loss = <span class="hljs-number">0</span>
    eval_preds = []
    <span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(tqdm(eval_dataloader)):
        batch = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> batch.items()}
        <span class="hljs-keyword">with</span> torch.no_grad():
            outputs = model(**batch)
        loss = outputs.loss
        eval_loss += loss.detach().<span class="hljs-built_in">float</span>()
        eval_preds.extend(
            tokenizer.batch_decode(torch.argmax(outputs.logits, -<span class="hljs-number">1</span>).detach().cpu().numpy(), skip_special_tokens=<span class="hljs-literal">True</span>)
        )

    eval_epoch_loss = eval_loss / <span class="hljs-built_in">len</span>(eval_dataloader)
    eval_ppl = torch.exp(eval_epoch_loss)
    train_epoch_loss = total_loss / <span class="hljs-built_in">len</span>(train_dataloader)
    train_ppl = torch.exp(train_epoch_loss)
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{epoch=}</span>: <span class="hljs-subst">{train_ppl=}</span> <span class="hljs-subst">{train_epoch_loss=}</span> <span class="hljs-subst">{eval_ppl=}</span> <span class="hljs-subst">{eval_epoch_loss=}</span>&quot;</span>)`}}),je=new w({props:{code:`correct = 0
total = 0
for pred, true in zip(eval_preds, dataset["validation"]["text_label"]):
    if pred.strip() == true.strip():
        correct += 1
    total += 1
accuracy = correct / total * 100
print(f"{accuracy=} % on the evaluation dataset")
print(f"{eval_preds[:10]=}")
print(f"{dataset['validation']['text_label'][:10]=}")
"accuracy=97.3568281938326 % on the evaluation dataset"
"eval_preds[:10]=['neutral', 'positive', 'neutral', 'positive', 'neutral', 'negative', 'negative', 'neutral', 'neutral', 'neutral']"
"dataset['validation']['text_label'][:10]=['neutral', 'positive', 'neutral', 'positive', 'neutral', 'negative', 'negative', 'neutral', 'neutral', 'neutral']"`,highlighted:`correct = <span class="hljs-number">0</span>
total = <span class="hljs-number">0</span>
<span class="hljs-keyword">for</span> pred, true <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(eval_preds, dataset[<span class="hljs-string">&quot;validation&quot;</span>][<span class="hljs-string">&quot;text_label&quot;</span>]):
    <span class="hljs-keyword">if</span> pred.strip() == true.strip():
        correct += <span class="hljs-number">1</span>
    total += <span class="hljs-number">1</span>
accuracy = correct / total * <span class="hljs-number">100</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{accuracy=}</span> % on the evaluation dataset&quot;</span>)
<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{eval_preds[:<span class="hljs-number">10</span>]=}</span>&quot;</span>)
<span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{dataset[<span class="hljs-string">&#x27;validation&#x27;</span>][<span class="hljs-string">&#x27;text_label&#x27;</span>][:<span class="hljs-number">10</span>]=}</span>&quot;</span>)
<span class="hljs-string">&quot;accuracy=97.3568281938326 % on the evaluation dataset&quot;</span>
<span class="hljs-string">&quot;eval_preds[:10]=[&#x27;neutral&#x27;, &#x27;positive&#x27;, &#x27;neutral&#x27;, &#x27;positive&#x27;, &#x27;neutral&#x27;, &#x27;negative&#x27;, &#x27;negative&#x27;, &#x27;neutral&#x27;, &#x27;neutral&#x27;, &#x27;neutral&#x27;]&quot;</span>
<span class="hljs-string">&quot;dataset[&#x27;validation&#x27;][&#x27;text_label&#x27;][:10]=[&#x27;neutral&#x27;, &#x27;positive&#x27;, &#x27;neutral&#x27;, &#x27;positive&#x27;, &#x27;neutral&#x27;, &#x27;negative&#x27;, &#x27;negative&#x27;, &#x27;neutral&#x27;, &#x27;neutral&#x27;, &#x27;neutral&#x27;]&quot;</span>`}}),qe=new Ce({}),Ee=new w({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

notebook_login()`}}),Se=new w({props:{code:`peft_model_id = "your-name/t5-large_PREFIX_TUNING_SEQ2SEQ"
model.push_to_hub("your-name/t5-large_PREFIX_TUNING_SEQ2SEQ", use_auth_token=True)`,highlighted:`peft_model_id = <span class="hljs-string">&quot;your-name/t5-large_PREFIX_TUNING_SEQ2SEQ&quot;</span>
model.push_to_hub(<span class="hljs-string">&quot;your-name/t5-large_PREFIX_TUNING_SEQ2SEQ&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>)`}}),Te=new Ce({}),ze=new w({props:{code:`from peft import PeftModel, PeftConfig

peft_model_id = "stevhliu/t5-large_PREFIX_TUNING_SEQ2SEQ"

config = PeftConfig.from_pretrained(peft_model_id)
model = AutoModelForSeq2SeqLM.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(model, peft_model_id)`,highlighted:`<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> PeftModel, PeftConfig

peft_model_id = <span class="hljs-string">&quot;stevhliu/t5-large_PREFIX_TUNING_SEQ2SEQ&quot;</span>

config = PeftConfig.from_pretrained(peft_model_id)
model = AutoModelForSeq2SeqLM.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(model, peft_model_id)`}}),Ae=new w({props:{code:`inputs = tokenizer(
    "The Lithuanian beer market made up 14.41 million liters in January , a rise of 0.8 percent from the year-earlier figure , the Lithuanian Brewers ' Association reporting citing the results from its members .",
    return_tensors="pt",
)`,highlighted:`inputs = tokenizer(
    <span class="hljs-string">&quot;The Lithuanian beer market made up 14.41 million liters in January , a rise of 0.8 percent from the year-earlier figure , the Lithuanian Brewers &#x27; Association reporting citing the results from its members .&quot;</span>,
    return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
)`}}),Le=new w({props:{code:`model.to(device)

with torch.no_grad():
    inputs = {k: v.to(device) for k, v in inputs.items()}
    outputs = model.generate(input_ids=inputs["input_ids"], max_new_tokens=10)
    print(tokenizer.batch_decode(outputs.detach().cpu().numpy(), skip_special_tokens=True))
["positive"]`,highlighted:`model.to(device)

<span class="hljs-keyword">with</span> torch.no_grad():
    inputs = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> inputs.items()}
    outputs = model.generate(input_ids=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>], max_new_tokens=<span class="hljs-number">10</span>)
    <span class="hljs-built_in">print</span>(tokenizer.batch_decode(outputs.detach().cpu().numpy(), skip_special_tokens=<span class="hljs-literal">True</span>))
[<span class="hljs-string">&quot;positive&quot;</span>]`}}),{c(){v=o("meta"),Q=d(),$=o("h1"),q=o("a"),I=o("span"),h(j.$$.fragment),T=d(),H=o("span"),Sa=l("Prefix tuning for conditional generation"),zt=d(),h(ae.$$.fragment),At=d(),z=o("p"),Ta=l("Prefix tuning is an additive method where only a sequence of continuous task-specific vectors is attached to the beginning of the input, or "),We=o("em"),za=l("prefix"),Aa=l(". Only the prefix parameters are optimized and added to the hidden states in every layer of the model. The tokens of the input sequence can still attend to the prefix as "),et=o("em"),La=l("virtual tokens"),Ma=l(". As a result, prefix tuning stores 1000x fewer parameters than a fully finetuned model, which means you can use one large language model for many tasks."),Lt=d(),h(B.$$.fragment),Mt=d(),E=o("p"),Ca=l("This guide will show you how to apply prefix tuning to train a "),se=o("a"),tt=o("code"),Da=l("t5-large"),Ia=l(" model on the "),at=o("code"),Na=l("sentences_allagree"),Fa=l(" subset of the "),le=o("a"),Oa=l("financial_phrasebank"),Ua=l(" dataset."),Ct=d(),De=o("p"),Ra=l("Before you begin, make sure you have all the necessary libraries installed:"),Dt=d(),h(ne.$$.fragment),It=d(),N=o("h2"),X=o("a"),st=o("span"),h(oe.$$.fragment),Ga=d(),lt=o("span"),Qa=l("Setup"),Nt=d(),A=o("p"),Ha=l("Start by defining the model and tokenizer, text and label columns, and some hyperparameters so it\u2019ll be easier to start training faster later. Set the environment variable "),nt=o("code"),Ba=l("TOKENIZERS_PARALLELSIM"),Xa=l(" to "),ot=o("code"),Ka=l("false"),Va=l(" to disable the fast Rust-based tokenizer which processes data in parallel by default so you can use multiprocessing in Python."),Ft=d(),h(re.$$.fragment),Ot=d(),F=o("h2"),K=o("a"),rt=o("span"),h(ie.$$.fragment),Ya=d(),it=o("span"),Za=l("Load dataset"),Ut=d(),L=o("p"),Ja=l("For this guide, you\u2019ll train on the "),pt=o("code"),Wa=l("sentences_allagree"),es=l(" subset of the "),pe=o("a"),ut=o("code"),ts=l("financial_phrasebank"),as=l(" dataset. This dataset contains financial news categorized by sentiment."),Rt=d(),k=o("p"),ss=l("Use \u{1F917} "),ue=o("a"),ls=l("Datasets"),ns=d(),de=o("a"),os=l("train_test_split"),rs=l(" function to create a training and validation split and convert the "),dt=o("code"),is=l("label"),ps=l(" value to the more readable "),ft=o("code"),us=l("text_label"),ds=l(". All of the changes can be applied with the "),fe=o("a"),fs=l("map"),hs=l(" function:"),Gt=d(),h(he.$$.fragment),Qt=d(),O=o("h2"),V=o("a"),ht=o("span"),h(ce.$$.fragment),cs=d(),ct=o("span"),ms=l("Preprocess dataset"),Ht=d(),M=o("p"),_s=l("Initialize a tokenizer, and create a function to pad and truncate the "),mt=o("code"),gs=l("model_inputs"),bs=l(" and "),_t=o("code"),vs=l("labels"),$s=l(":"),Bt=d(),h(me.$$.fragment),Xt=d(),C=o("p"),ks=l("Use the "),_e=o("a"),ys=l("map"),ws=l(" function to apply the "),gt=o("code"),xs=l("preprocess_function"),js=l(" to the dataset. You can remove the unprocessed columns since the model doesn\u2019t need them anymore:"),Kt=d(),h(ge.$$.fragment),Vt=d(),x=o("p"),qs=l("Create a "),be=o("a"),bt=o("code"),Es=l("DataLoader"),Ps=l(" from the "),vt=o("code"),Ss=l("train"),Ts=l(" and "),$t=o("code"),zs=l("eval"),As=l(" datasets. Set "),kt=o("code"),Ls=l("pin_memory=True"),Ms=l(" to speed up the data transfer to the GPU during training if the samples in your dataset are on a CPU."),Yt=d(),h(ve.$$.fragment),Zt=d(),U=o("h2"),Y=o("a"),yt=o("span"),h($e.$$.fragment),Cs=d(),wt=o("span"),Ds=l("Train model"),Jt=d(),y=o("p"),Is=l("Now you can setup your model and make sure it is ready for training. Specify the task in "),Ie=o("a"),Ns=l("PrefixTuningConfig"),Fs=l(", create the base "),xt=o("code"),Os=l("t5-large"),Us=l(" model from "),ke=o("a"),Rs=l("AutoModelForSeq2SeqLM"),Gs=l(", and then wrap the model and configuration in a "),Ne=o("a"),Qs=l("PeftModel"),Hs=l(". Feel free to print the "),Fe=o("a"),Bs=l("PeftModel"),Xs=l("\u2019s parameters and compare it to fully training all the model parameters to see how much more efficient it is!"),Wt=d(),h(ye.$$.fragment),ea=d(),Oe=o("p"),Ks=l("Setup the optimizer and learning rate scheduler:"),ta=d(),h(we.$$.fragment),aa=d(),Ue=o("p"),Vs=l("Move the model to the GPU, and then write a training loop to begin!"),sa=d(),h(xe.$$.fragment),la=d(),Re=o("p"),Ys=l("Let\u2019s see how well the model performs on the validation set:"),na=d(),h(je.$$.fragment),oa=d(),Ge=o("p"),Zs=l("97% accuracy in just a few minutes; pretty good!"),ra=d(),R=o("h2"),Z=o("a"),jt=o("span"),h(qe.$$.fragment),Js=d(),qt=o("span"),Ws=l("Share model"),ia=d(),Qe=o("p"),el=l("You can store and share your model on the Hub if you\u2019d like. Login to your Hugging Face account and enter your token when prompted:"),pa=d(),h(Ee.$$.fragment),ua=d(),J=o("p"),tl=l("Upload the model to a specifc model repository on the Hub with the "),Pe=o("a"),al=l("push_to_hub"),sl=l(" function:"),da=d(),h(Se.$$.fragment),fa=d(),He=o("p"),ll=l("If you check the model file size in the repository, you\u2019ll see that it is only 3.93MB! \u{1F90F}"),ha=d(),G=o("h2"),W=o("a"),Et=o("span"),h(Te.$$.fragment),nl=d(),Pt=o("span"),ol=l("Inference"),ca=d(),Be=o("p"),rl=l("Once the model has been uploaded to the Hub, anyone can easily use it for inference. Load the configuration and model:"),ma=d(),h(ze.$$.fragment),_a=d(),Xe=o("p"),il=l("Get and tokenize some text about financial news:"),ga=d(),h(Ae.$$.fragment),ba=d(),ee=o("p"),pl=l("Put the model on a GPU and "),St=o("em"),ul=l("generate"),dl=l(" the predicted text sentiment:"),va=d(),h(Le.$$.fragment),this.h()},l(e){const s=xn('[data-svelte="svelte-1phssyn"]',document.head);v=r(s,"META",{name:!0,content:!0}),s.forEach(t),Q=f(e),$=r(e,"H1",{class:!0});var Me=i($);q=r(Me,"A",{id:!0,class:!0,href:!0});var fl=i(q);I=r(fl,"SPAN",{});var hl=i(I);c(j.$$.fragment,hl),hl.forEach(t),fl.forEach(t),T=f(Me),H=r(Me,"SPAN",{});var cl=i(H);Sa=n(cl,"Prefix tuning for conditional generation"),cl.forEach(t),Me.forEach(t),zt=f(e),c(ae.$$.fragment,e),At=f(e),z=r(e,"P",{});var Ke=i(z);Ta=n(Ke,"Prefix tuning is an additive method where only a sequence of continuous task-specific vectors is attached to the beginning of the input, or "),We=r(Ke,"EM",{});var ml=i(We);za=n(ml,"prefix"),ml.forEach(t),Aa=n(Ke,". Only the prefix parameters are optimized and added to the hidden states in every layer of the model. The tokens of the input sequence can still attend to the prefix as "),et=r(Ke,"EM",{});var _l=i(et);La=n(_l,"virtual tokens"),_l.forEach(t),Ma=n(Ke,". As a result, prefix tuning stores 1000x fewer parameters than a fully finetuned model, which means you can use one large language model for many tasks."),Ke.forEach(t),Lt=f(e),c(B.$$.fragment,e),Mt=f(e),E=r(e,"P",{});var te=i(E);Ca=n(te,"This guide will show you how to apply prefix tuning to train a "),se=r(te,"A",{href:!0,rel:!0});var gl=i(se);tt=r(gl,"CODE",{});var bl=i(tt);Da=n(bl,"t5-large"),bl.forEach(t),gl.forEach(t),Ia=n(te," model on the "),at=r(te,"CODE",{});var vl=i(at);Na=n(vl,"sentences_allagree"),vl.forEach(t),Fa=n(te," subset of the "),le=r(te,"A",{href:!0,rel:!0});var $l=i(le);Oa=n($l,"financial_phrasebank"),$l.forEach(t),Ua=n(te," dataset."),te.forEach(t),Ct=f(e),De=r(e,"P",{});var kl=i(De);Ra=n(kl,"Before you begin, make sure you have all the necessary libraries installed:"),kl.forEach(t),Dt=f(e),c(ne.$$.fragment,e),It=f(e),N=r(e,"H2",{class:!0});var ka=i(N);X=r(ka,"A",{id:!0,class:!0,href:!0});var yl=i(X);st=r(yl,"SPAN",{});var wl=i(st);c(oe.$$.fragment,wl),wl.forEach(t),yl.forEach(t),Ga=f(ka),lt=r(ka,"SPAN",{});var xl=i(lt);Qa=n(xl,"Setup"),xl.forEach(t),ka.forEach(t),Nt=f(e),A=r(e,"P",{});var Ve=i(A);Ha=n(Ve,"Start by defining the model and tokenizer, text and label columns, and some hyperparameters so it\u2019ll be easier to start training faster later. Set the environment variable "),nt=r(Ve,"CODE",{});var jl=i(nt);Ba=n(jl,"TOKENIZERS_PARALLELSIM"),jl.forEach(t),Xa=n(Ve," to "),ot=r(Ve,"CODE",{});var ql=i(ot);Ka=n(ql,"false"),ql.forEach(t),Va=n(Ve," to disable the fast Rust-based tokenizer which processes data in parallel by default so you can use multiprocessing in Python."),Ve.forEach(t),Ft=f(e),c(re.$$.fragment,e),Ot=f(e),F=r(e,"H2",{class:!0});var ya=i(F);K=r(ya,"A",{id:!0,class:!0,href:!0});var El=i(K);rt=r(El,"SPAN",{});var Pl=i(rt);c(ie.$$.fragment,Pl),Pl.forEach(t),El.forEach(t),Ya=f(ya),it=r(ya,"SPAN",{});var Sl=i(it);Za=n(Sl,"Load dataset"),Sl.forEach(t),ya.forEach(t),Ut=f(e),L=r(e,"P",{});var Ye=i(L);Ja=n(Ye,"For this guide, you\u2019ll train on the "),pt=r(Ye,"CODE",{});var Tl=i(pt);Wa=n(Tl,"sentences_allagree"),Tl.forEach(t),es=n(Ye," subset of the "),pe=r(Ye,"A",{href:!0,rel:!0});var zl=i(pe);ut=r(zl,"CODE",{});var Al=i(ut);ts=n(Al,"financial_phrasebank"),Al.forEach(t),zl.forEach(t),as=n(Ye," dataset. This dataset contains financial news categorized by sentiment."),Ye.forEach(t),Rt=f(e),k=r(e,"P",{});var P=i(k);ss=n(P,"Use \u{1F917} "),ue=r(P,"A",{href:!0,rel:!0});var Ll=i(ue);ls=n(Ll,"Datasets"),Ll.forEach(t),ns=f(P),de=r(P,"A",{href:!0,rel:!0});var Ml=i(de);os=n(Ml,"train_test_split"),Ml.forEach(t),rs=n(P," function to create a training and validation split and convert the "),dt=r(P,"CODE",{});var Cl=i(dt);is=n(Cl,"label"),Cl.forEach(t),ps=n(P," value to the more readable "),ft=r(P,"CODE",{});var Dl=i(ft);us=n(Dl,"text_label"),Dl.forEach(t),ds=n(P,". All of the changes can be applied with the "),fe=r(P,"A",{href:!0,rel:!0});var Il=i(fe);fs=n(Il,"map"),Il.forEach(t),hs=n(P," function:"),P.forEach(t),Gt=f(e),c(he.$$.fragment,e),Qt=f(e),O=r(e,"H2",{class:!0});var wa=i(O);V=r(wa,"A",{id:!0,class:!0,href:!0});var Nl=i(V);ht=r(Nl,"SPAN",{});var Fl=i(ht);c(ce.$$.fragment,Fl),Fl.forEach(t),Nl.forEach(t),cs=f(wa),ct=r(wa,"SPAN",{});var Ol=i(ct);ms=n(Ol,"Preprocess dataset"),Ol.forEach(t),wa.forEach(t),Ht=f(e),M=r(e,"P",{});var Ze=i(M);_s=n(Ze,"Initialize a tokenizer, and create a function to pad and truncate the "),mt=r(Ze,"CODE",{});var Ul=i(mt);gs=n(Ul,"model_inputs"),Ul.forEach(t),bs=n(Ze," and "),_t=r(Ze,"CODE",{});var Rl=i(_t);vs=n(Rl,"labels"),Rl.forEach(t),$s=n(Ze,":"),Ze.forEach(t),Bt=f(e),c(me.$$.fragment,e),Xt=f(e),C=r(e,"P",{});var Je=i(C);ks=n(Je,"Use the "),_e=r(Je,"A",{href:!0,rel:!0});var Gl=i(_e);ys=n(Gl,"map"),Gl.forEach(t),ws=n(Je," function to apply the "),gt=r(Je,"CODE",{});var Ql=i(gt);xs=n(Ql,"preprocess_function"),Ql.forEach(t),js=n(Je," to the dataset. You can remove the unprocessed columns since the model doesn\u2019t need them anymore:"),Je.forEach(t),Kt=f(e),c(ge.$$.fragment,e),Vt=f(e),x=r(e,"P",{});var D=i(x);qs=n(D,"Create a "),be=r(D,"A",{href:!0,rel:!0});var Hl=i(be);bt=r(Hl,"CODE",{});var Bl=i(bt);Es=n(Bl,"DataLoader"),Bl.forEach(t),Hl.forEach(t),Ps=n(D," from the "),vt=r(D,"CODE",{});var Xl=i(vt);Ss=n(Xl,"train"),Xl.forEach(t),Ts=n(D," and "),$t=r(D,"CODE",{});var Kl=i($t);zs=n(Kl,"eval"),Kl.forEach(t),As=n(D," datasets. Set "),kt=r(D,"CODE",{});var Vl=i(kt);Ls=n(Vl,"pin_memory=True"),Vl.forEach(t),Ms=n(D," to speed up the data transfer to the GPU during training if the samples in your dataset are on a CPU."),D.forEach(t),Yt=f(e),c(ve.$$.fragment,e),Zt=f(e),U=r(e,"H2",{class:!0});var xa=i(U);Y=r(xa,"A",{id:!0,class:!0,href:!0});var Yl=i(Y);yt=r(Yl,"SPAN",{});var Zl=i(yt);c($e.$$.fragment,Zl),Zl.forEach(t),Yl.forEach(t),Cs=f(xa),wt=r(xa,"SPAN",{});var Jl=i(wt);Ds=n(Jl,"Train model"),Jl.forEach(t),xa.forEach(t),Jt=f(e),y=r(e,"P",{});var S=i(y);Is=n(S,"Now you can setup your model and make sure it is ready for training. Specify the task in "),Ie=r(S,"A",{href:!0});var Wl=i(Ie);Ns=n(Wl,"PrefixTuningConfig"),Wl.forEach(t),Fs=n(S,", create the base "),xt=r(S,"CODE",{});var en=i(xt);Os=n(en,"t5-large"),en.forEach(t),Us=n(S," model from "),ke=r(S,"A",{href:!0,rel:!0});var tn=i(ke);Rs=n(tn,"AutoModelForSeq2SeqLM"),tn.forEach(t),Gs=n(S,", and then wrap the model and configuration in a "),Ne=r(S,"A",{href:!0});var an=i(Ne);Qs=n(an,"PeftModel"),an.forEach(t),Hs=n(S,". Feel free to print the "),Fe=r(S,"A",{href:!0});var sn=i(Fe);Bs=n(sn,"PeftModel"),sn.forEach(t),Xs=n(S,"\u2019s parameters and compare it to fully training all the model parameters to see how much more efficient it is!"),S.forEach(t),Wt=f(e),c(ye.$$.fragment,e),ea=f(e),Oe=r(e,"P",{});var ln=i(Oe);Ks=n(ln,"Setup the optimizer and learning rate scheduler:"),ln.forEach(t),ta=f(e),c(we.$$.fragment,e),aa=f(e),Ue=r(e,"P",{});var nn=i(Ue);Vs=n(nn,"Move the model to the GPU, and then write a training loop to begin!"),nn.forEach(t),sa=f(e),c(xe.$$.fragment,e),la=f(e),Re=r(e,"P",{});var on=i(Re);Ys=n(on,"Let\u2019s see how well the model performs on the validation set:"),on.forEach(t),na=f(e),c(je.$$.fragment,e),oa=f(e),Ge=r(e,"P",{});var rn=i(Ge);Zs=n(rn,"97% accuracy in just a few minutes; pretty good!"),rn.forEach(t),ra=f(e),R=r(e,"H2",{class:!0});var ja=i(R);Z=r(ja,"A",{id:!0,class:!0,href:!0});var pn=i(Z);jt=r(pn,"SPAN",{});var un=i(jt);c(qe.$$.fragment,un),un.forEach(t),pn.forEach(t),Js=f(ja),qt=r(ja,"SPAN",{});var dn=i(qt);Ws=n(dn,"Share model"),dn.forEach(t),ja.forEach(t),ia=f(e),Qe=r(e,"P",{});var fn=i(Qe);el=n(fn,"You can store and share your model on the Hub if you\u2019d like. Login to your Hugging Face account and enter your token when prompted:"),fn.forEach(t),pa=f(e),c(Ee.$$.fragment,e),ua=f(e),J=r(e,"P",{});var qa=i(J);tl=n(qa,"Upload the model to a specifc model repository on the Hub with the "),Pe=r(qa,"A",{href:!0,rel:!0});var hn=i(Pe);al=n(hn,"push_to_hub"),hn.forEach(t),sl=n(qa," function:"),qa.forEach(t),da=f(e),c(Se.$$.fragment,e),fa=f(e),He=r(e,"P",{});var cn=i(He);ll=n(cn,"If you check the model file size in the repository, you\u2019ll see that it is only 3.93MB! \u{1F90F}"),cn.forEach(t),ha=f(e),G=r(e,"H2",{class:!0});var Ea=i(G);W=r(Ea,"A",{id:!0,class:!0,href:!0});var mn=i(W);Et=r(mn,"SPAN",{});var _n=i(Et);c(Te.$$.fragment,_n),_n.forEach(t),mn.forEach(t),nl=f(Ea),Pt=r(Ea,"SPAN",{});var gn=i(Pt);ol=n(gn,"Inference"),gn.forEach(t),Ea.forEach(t),ca=f(e),Be=r(e,"P",{});var bn=i(Be);rl=n(bn,"Once the model has been uploaded to the Hub, anyone can easily use it for inference. Load the configuration and model:"),bn.forEach(t),ma=f(e),c(ze.$$.fragment,e),_a=f(e),Xe=r(e,"P",{});var vn=i(Xe);il=n(vn,"Get and tokenize some text about financial news:"),vn.forEach(t),ga=f(e),c(Ae.$$.fragment,e),ba=f(e),ee=r(e,"P",{});var Pa=i(ee);pl=n(Pa,"Put the model on a GPU and "),St=r(Pa,"EM",{});var $n=i(St);ul=n($n,"generate"),$n.forEach(t),dl=n(Pa," the predicted text sentiment:"),Pa.forEach(t),va=f(e),c(Le.$$.fragment,e),this.h()},h(){u(v,"name","hf:doc:metadata"),u(v,"content",JSON.stringify(Tn)),u(q,"id","prefix-tuning-for-conditional-generation"),u(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(q,"href","#prefix-tuning-for-conditional-generation"),u($,"class","relative group"),u(se,"href","https://huggingface.co/t5-large"),u(se,"rel","nofollow"),u(le,"href","https://huggingface.co/datasets/financial_phrasebank"),u(le,"rel","nofollow"),u(X,"id","setup"),u(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(X,"href","#setup"),u(N,"class","relative group"),u(K,"id","load-dataset"),u(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(K,"href","#load-dataset"),u(F,"class","relative group"),u(pe,"href","https://huggingface.co/datasets/financial_phrasebank"),u(pe,"rel","nofollow"),u(ue,"href","https://huggingface.co/docs/datasets/index"),u(ue,"rel","nofollow"),u(de,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.train_test_split"),u(de,"rel","nofollow"),u(fe,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),u(fe,"rel","nofollow"),u(V,"id","preprocess-dataset"),u(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(V,"href","#preprocess-dataset"),u(O,"class","relative group"),u(_e,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),u(_e,"rel","nofollow"),u(be,"href","https://pytorch.org/docs/stable/data.html#torch.utils.data.DataLoader"),u(be,"rel","nofollow"),u(Y,"id","train-model"),u(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Y,"href","#train-model"),u(U,"class","relative group"),u(Ie,"href","/docs/peft/main/en/package_reference/tuners#peft.PrefixTuningConfig"),u(ke,"href","https://huggingface.co/docs/transformers/main/en/model_doc/auto#transformers.AutoModelForSeq2SeqLM"),u(ke,"rel","nofollow"),u(Ne,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),u(Fe,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),u(Z,"id","share-model"),u(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Z,"href","#share-model"),u(R,"class","relative group"),u(Pe,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.push_to_hub"),u(Pe,"rel","nofollow"),u(W,"id","inference"),u(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(W,"href","#inference"),u(G,"class","relative group")},m(e,s){a(document.head,v),p(e,Q,s),p(e,$,s),a($,q),a(q,I),m(j,I,null),a($,T),a($,H),a(H,Sa),p(e,zt,s),m(ae,e,s),p(e,At,s),p(e,z,s),a(z,Ta),a(z,We),a(We,za),a(z,Aa),a(z,et),a(et,La),a(z,Ma),p(e,Lt,s),m(B,e,s),p(e,Mt,s),p(e,E,s),a(E,Ca),a(E,se),a(se,tt),a(tt,Da),a(E,Ia),a(E,at),a(at,Na),a(E,Fa),a(E,le),a(le,Oa),a(E,Ua),p(e,Ct,s),p(e,De,s),a(De,Ra),p(e,Dt,s),m(ne,e,s),p(e,It,s),p(e,N,s),a(N,X),a(X,st),m(oe,st,null),a(N,Ga),a(N,lt),a(lt,Qa),p(e,Nt,s),p(e,A,s),a(A,Ha),a(A,nt),a(nt,Ba),a(A,Xa),a(A,ot),a(ot,Ka),a(A,Va),p(e,Ft,s),m(re,e,s),p(e,Ot,s),p(e,F,s),a(F,K),a(K,rt),m(ie,rt,null),a(F,Ya),a(F,it),a(it,Za),p(e,Ut,s),p(e,L,s),a(L,Ja),a(L,pt),a(pt,Wa),a(L,es),a(L,pe),a(pe,ut),a(ut,ts),a(L,as),p(e,Rt,s),p(e,k,s),a(k,ss),a(k,ue),a(ue,ls),a(k,ns),a(k,de),a(de,os),a(k,rs),a(k,dt),a(dt,is),a(k,ps),a(k,ft),a(ft,us),a(k,ds),a(k,fe),a(fe,fs),a(k,hs),p(e,Gt,s),m(he,e,s),p(e,Qt,s),p(e,O,s),a(O,V),a(V,ht),m(ce,ht,null),a(O,cs),a(O,ct),a(ct,ms),p(e,Ht,s),p(e,M,s),a(M,_s),a(M,mt),a(mt,gs),a(M,bs),a(M,_t),a(_t,vs),a(M,$s),p(e,Bt,s),m(me,e,s),p(e,Xt,s),p(e,C,s),a(C,ks),a(C,_e),a(_e,ys),a(C,ws),a(C,gt),a(gt,xs),a(C,js),p(e,Kt,s),m(ge,e,s),p(e,Vt,s),p(e,x,s),a(x,qs),a(x,be),a(be,bt),a(bt,Es),a(x,Ps),a(x,vt),a(vt,Ss),a(x,Ts),a(x,$t),a($t,zs),a(x,As),a(x,kt),a(kt,Ls),a(x,Ms),p(e,Yt,s),m(ve,e,s),p(e,Zt,s),p(e,U,s),a(U,Y),a(Y,yt),m($e,yt,null),a(U,Cs),a(U,wt),a(wt,Ds),p(e,Jt,s),p(e,y,s),a(y,Is),a(y,Ie),a(Ie,Ns),a(y,Fs),a(y,xt),a(xt,Os),a(y,Us),a(y,ke),a(ke,Rs),a(y,Gs),a(y,Ne),a(Ne,Qs),a(y,Hs),a(y,Fe),a(Fe,Bs),a(y,Xs),p(e,Wt,s),m(ye,e,s),p(e,ea,s),p(e,Oe,s),a(Oe,Ks),p(e,ta,s),m(we,e,s),p(e,aa,s),p(e,Ue,s),a(Ue,Vs),p(e,sa,s),m(xe,e,s),p(e,la,s),p(e,Re,s),a(Re,Ys),p(e,na,s),m(je,e,s),p(e,oa,s),p(e,Ge,s),a(Ge,Zs),p(e,ra,s),p(e,R,s),a(R,Z),a(Z,jt),m(qe,jt,null),a(R,Js),a(R,qt),a(qt,Ws),p(e,ia,s),p(e,Qe,s),a(Qe,el),p(e,pa,s),m(Ee,e,s),p(e,ua,s),p(e,J,s),a(J,tl),a(J,Pe),a(Pe,al),a(J,sl),p(e,da,s),m(Se,e,s),p(e,fa,s),p(e,He,s),a(He,ll),p(e,ha,s),p(e,G,s),a(G,W),a(W,Et),m(Te,Et,null),a(G,nl),a(G,Pt),a(Pt,ol),p(e,ca,s),p(e,Be,s),a(Be,rl),p(e,ma,s),m(ze,e,s),p(e,_a,s),p(e,Xe,s),a(Xe,il),p(e,ga,s),m(Ae,e,s),p(e,ba,s),p(e,ee,s),a(ee,pl),a(ee,St),a(St,ul),a(ee,dl),p(e,va,s),m(Le,e,s),$a=!0},p(e,[s]){const Me={};s&2&&(Me.$$scope={dirty:s,ctx:e}),B.$set(Me)},i(e){$a||(_(j.$$.fragment,e),_(ae.$$.fragment,e),_(B.$$.fragment,e),_(ne.$$.fragment,e),_(oe.$$.fragment,e),_(re.$$.fragment,e),_(ie.$$.fragment,e),_(he.$$.fragment,e),_(ce.$$.fragment,e),_(me.$$.fragment,e),_(ge.$$.fragment,e),_(ve.$$.fragment,e),_($e.$$.fragment,e),_(ye.$$.fragment,e),_(we.$$.fragment,e),_(xe.$$.fragment,e),_(je.$$.fragment,e),_(qe.$$.fragment,e),_(Ee.$$.fragment,e),_(Se.$$.fragment,e),_(Te.$$.fragment,e),_(ze.$$.fragment,e),_(Ae.$$.fragment,e),_(Le.$$.fragment,e),$a=!0)},o(e){g(j.$$.fragment,e),g(ae.$$.fragment,e),g(B.$$.fragment,e),g(ne.$$.fragment,e),g(oe.$$.fragment,e),g(re.$$.fragment,e),g(ie.$$.fragment,e),g(he.$$.fragment,e),g(ce.$$.fragment,e),g(me.$$.fragment,e),g(ge.$$.fragment,e),g(ve.$$.fragment,e),g($e.$$.fragment,e),g(ye.$$.fragment,e),g(we.$$.fragment,e),g(xe.$$.fragment,e),g(je.$$.fragment,e),g(qe.$$.fragment,e),g(Ee.$$.fragment,e),g(Se.$$.fragment,e),g(Te.$$.fragment,e),g(ze.$$.fragment,e),g(Ae.$$.fragment,e),g(Le.$$.fragment,e),$a=!1},d(e){t(v),e&&t(Q),e&&t($),b(j),e&&t(zt),b(ae,e),e&&t(At),e&&t(z),e&&t(Lt),b(B,e),e&&t(Mt),e&&t(E),e&&t(Ct),e&&t(De),e&&t(Dt),b(ne,e),e&&t(It),e&&t(N),b(oe),e&&t(Nt),e&&t(A),e&&t(Ft),b(re,e),e&&t(Ot),e&&t(F),b(ie),e&&t(Ut),e&&t(L),e&&t(Rt),e&&t(k),e&&t(Gt),b(he,e),e&&t(Qt),e&&t(O),b(ce),e&&t(Ht),e&&t(M),e&&t(Bt),b(me,e),e&&t(Xt),e&&t(C),e&&t(Kt),b(ge,e),e&&t(Vt),e&&t(x),e&&t(Yt),b(ve,e),e&&t(Zt),e&&t(U),b($e),e&&t(Jt),e&&t(y),e&&t(Wt),b(ye,e),e&&t(ea),e&&t(Oe),e&&t(ta),b(we,e),e&&t(aa),e&&t(Ue),e&&t(sa),b(xe,e),e&&t(la),e&&t(Re),e&&t(na),b(je,e),e&&t(oa),e&&t(Ge),e&&t(ra),e&&t(R),b(qe),e&&t(ia),e&&t(Qe),e&&t(pa),b(Ee,e),e&&t(ua),e&&t(J),e&&t(da),b(Se,e),e&&t(fa),e&&t(He),e&&t(ha),e&&t(G),b(Te),e&&t(ca),e&&t(Be),e&&t(ma),b(ze,e),e&&t(_a),e&&t(Xe),e&&t(ga),b(Ae,e),e&&t(ba),e&&t(ee),e&&t(va),b(Le,e)}}}const Tn={local:"prefix-tuning-for-conditional-generation",sections:[{local:"setup",title:"Setup"},{local:"load-dataset",title:"Load dataset"},{local:"preprocess-dataset",title:"Preprocess dataset"},{local:"train-model",title:"Train model"},{local:"share-model",title:"Share model"},{local:"inference",title:"Inference"}],title:"Prefix tuning for conditional generation"};function zn(Tt){return jn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Dn extends kn{constructor(v){super();yn(this,v,zn,Sn,wn,{})}}export{Dn as default,Tn as metadata};
